qlserver 5.9 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203
  1. #!/bin/bash
  2. # Project: Game Server Managers - LinuxGSM
  3. # Author: Daniel Gibbs
  4. # License: MIT License, Copyright (c) 2016 Daniel Gibbs
  5. # Purpose: Quake Live | Server Management Script
  6. # Contributors: https://github.com/GameServerManagers/LinuxGSM/graphs/contributors
  7. # Documentation: https://github.com/GameServerManagers/LinuxGSM/wiki
  8. # Website: https://gameservermanagers.com
  9. # Debugging
  10. if [ -f ".dev-debug" ]; then
  11. exec 5>dev-debug.log
  12. BASH_XTRACEFD="5"
  13. set -x
  14. fi
  15. version="161030"
  16. ##########################
  17. ######## Settings ########
  18. ##########################
  19. #### Server Settings ####
  20. ## Server Start Settings | https://github.com/GameServerManagers/LinuxGSM/wiki/Start-Parameters
  21. arch="x64" # x64 or x86
  22. port="27960"
  23. rconport="28960"
  24. rconpassword="CHANGE_ME"
  25. statsport="${port}"
  26. statspassword="CHANGE_ME"
  27. mappool='mappool.txt'
  28. ip="0.0.0.0"
  29. ## Server Start Command | https://github.com/GameServerManagers/LinuxGSM/wiki/Start-Parameters#additional-parameters
  30. # Edit with care | Install/Config Guide : https://steamcommunity.com/sharedfiles/filedetails/?id=542966946
  31. # Console Commands : http://www.regurge.at/ql/
  32. fn_parms(){
  33. parms="+set net_strict 1 +set net_ip ${ip} +set net_port ${port} +set fs_homepath ${filesdir}/${port} +set zmq_rcon_enable 1 +set zmq_rcon_port ${rconport} +set zmq_rcon_password ${rconpassword} +set zmq_stats_enable 1 +set zmq_stats_password ${statspassword} +set zmq_stats_port ${statsport} +set sv_mapPoolFile ${mappool} +exec ${servercfg}"
  34. }
  35. #### LinuxGSM Settings ####
  36. ## Notification Alerts
  37. # (on|off)
  38. # Email Alerts | https://github.com/GameServerManagers/LinuxGSM/wiki/Email
  39. emailalert="off"
  40. email="email@example.com"
  41. emailfrom=""
  42. # Pushbullet Alerts | https://github.com/GameServerManagers/LinuxGSM/wiki/Pushbullet
  43. pushbulletalert="off"
  44. pushbullettoken="accesstoken"
  45. ## Updating | https://github.com/GameServerManagers/LinuxGSM/wiki/Update
  46. updateonstart="off"
  47. ## Backup | https://github.com/GameServerManagers/LinuxGSM/wiki/Backup
  48. maxbackups="4"
  49. maxbackupdays="30"
  50. stoponbackup="on"
  51. ## Logging | https://github.com/GameServerManagers/LinuxGSM/wiki/Logging
  52. consolelogging="on"
  53. logdays="7"
  54. #### LinuxGSM Advanced Settings ####
  55. ## SteamCMD Settings
  56. # Server appid
  57. appid="349090"
  58. # Steam App Branch Select
  59. # Allows to opt into the various Steam app branches. Default branch is "".
  60. # Example: "-beta latest_experimental"
  61. branch=""
  62. ## Github Branch Select
  63. # Allows for the use of different function files
  64. # from a different repo and/or branch.
  65. githubuser="GameServerManagers"
  66. githubrepo="LinuxGSM"
  67. githubbranch="master"
  68. ## LinuxGSM Server Details
  69. # Do not edit
  70. gamename="Quake Live"
  71. engine="idtech3_ql"
  72. ## Service Name | https://github.com/GameServerManagers/LinuxGSM/wiki/Multiple-Servers
  73. servicename="ql-server"
  74. #### Directories ####
  75. # Edit with care
  76. ## Work Directories
  77. rootdir="$(dirname $(readlink -f "${BASH_SOURCE[0]}"))"
  78. selfname="$(basename $(readlink -f "${BASH_SOURCE[0]}"))"
  79. lockselfname=".${servicename}.lock"
  80. lgsmdir="${rootdir}/lgsm"
  81. functionsdir="${lgsmdir}/functions"
  82. libdir="${lgsmdir}/lib"
  83. tmpdir="${lgsmdir}/tmp"
  84. filesdir="${rootdir}/serverfiles"
  85. ## Server Specific Directories
  86. systemdir="${filesdir}"
  87. executabledir="${filesdir}"
  88. executable=$([ "${arch}" == 'x64' ] && echo "./run_server_x64.sh" || echo "./run_server_x86.sh")
  89. servercfg="${servicename}.cfg"
  90. servercfgdefault="server.cfg"
  91. servercfgdir="${filesdir}/baseq3"
  92. servercfgfullpath="${servercfgdir}/${servercfg}"
  93. ## Backup Directory
  94. backupdir="${rootdir}/backups"
  95. ## Logging Directories
  96. gamelogdir="${rootdir}/log/server"
  97. scriptlogdir="${rootdir}/log/script"
  98. consolelogdir="${rootdir}/log/console"
  99. gamelog="${gamelogdir}/${servicename}-game.log"
  100. scriptlog="${scriptlogdir}/${servicename}-script.log"
  101. consolelog="${consolelogdir}/${servicename}-console.log"
  102. emaillog="${scriptlogdir}/${servicename}-email.log"
  103. ## Logs Naming
  104. scriptlogdate="${scriptlogdir}/${servicename}-script-$(date '+%Y-%m-%d-%H:%M:%S').log"
  105. consolelogdate="${consolelogdir}/${servicename}-console-$(date '+%Y-%m-%d-%H:%M:%S').log"
  106. ########################
  107. ######## Script ########
  108. ###### Do not edit #####
  109. ########################
  110. # Fetches core_dl for file downloads
  111. fn_fetch_core_dl(){
  112. github_file_url_dir="lgsm/functions"
  113. github_file_url_name="${functionfile}"
  114. filedir="${functionsdir}"
  115. filename="${github_file_url_name}"
  116. githuburl="https://raw.githubusercontent.com/${githubuser}/${githubrepo}/${githubbranch}/${github_file_url_dir}/${github_file_url_name}"
  117. # If the file is missing, then download
  118. if [ ! -f "${filedir}/${filename}" ]; then
  119. if [ ! -d "${filedir}" ]; then
  120. mkdir -p "${filedir}"
  121. fi
  122. echo -e " fetching ${filename}...\c"
  123. # Check curl exists and use available path
  124. curlpaths="$(command -v curl 2>/dev/null) $(which curl >/dev/null 2>&1) /usr/bin/curl /bin/curl /usr/sbin/curl /sbin/curl)"
  125. for curlcmd in ${curlpaths}
  126. do
  127. if [ -x "${curlcmd}" ]; then
  128. break
  129. fi
  130. done
  131. # If curl exists download file
  132. if [ "$(basename ${curlcmd})" == "curl" ]; then
  133. curlfetch=$(${curlcmd} -s --fail -o "${filedir}/${filename}" "${githuburl}" 2>&1)
  134. if [ $? -ne 0 ]; then
  135. echo -e "\e[0;31mFAIL\e[0m\n"
  136. echo "${curlfetch}"
  137. echo -e "${githuburl}\n"
  138. exit 1
  139. else
  140. echo -e "\e[0;32mOK\e[0m"
  141. fi
  142. else
  143. echo -e "\e[0;31mFAIL\e[0m\n"
  144. echo "Curl is not installed!"
  145. echo -e ""
  146. exit 1
  147. fi
  148. chmod +x "${filedir}/${filename}"
  149. fi
  150. source "${filedir}/${filename}"
  151. }
  152. core_dl.sh(){
  153. # Functions are defined in core_functions.sh.
  154. functionfile="${FUNCNAME}"
  155. fn_fetch_core_dl
  156. }
  157. core_functions.sh(){
  158. # Functions are defined in core_functions.sh.
  159. functionfile="${FUNCNAME}"
  160. fn_fetch_core_dl
  161. }
  162. # Prevent from running this script as root.
  163. if [ "$(whoami)" = "root" ]; then
  164. if [ ! -f "${functionsdir}/core_functions.sh" ]||[ ! -f "${functionsdir}/check_root.sh" ]||[ ! -f "${functionsdir}/core_messages.sh" ]||[ ! -f "${functionsdir}/core_exit.sh" ]; then
  165. echo "[ FAIL ] Do NOT run this script as root!"
  166. exit 1
  167. else
  168. core_functions.sh
  169. check_root.sh
  170. fi
  171. fi
  172. core_dl.sh
  173. core_functions.sh
  174. getopt=$1
  175. core_getopt.sh